<b><center>Connman System Tray (CMST)</center></b>
<b><center>Change Log</center></b>
<b> 2023.03.14</b>
<ul>
<li>Use short options in gzip for Alpine Linux (PR #292 from 154pinkchairs).</li>
<li>Do not update display widgets if minimized or running in the system tray.</li>
<li>Added translations for Catalan, Korean</li>
<li>Numberous translation updates</li>
</ul>
<b> 2022.11.30</b>
<ul>
<li>Changes to allow compile with QT6 (PR #278 from kitsnotes).</li>
<li>Numerous translation updates</li>
<li>All columns can be resized in the Technologies windows in the Status tab.</li>
</ul>
<b> 2022.05.01</b>
<ul>
<li>Revise startup process (issue #269).</li>
<li>Many improvements in IconManager.</li>
<li>VPN tab - implemented Remove function.</li>
<li>VPN tab - implemented Create function.</li>
</ul>
<b> 2022.03.13</b>
<ul>
<li>Revised open, save, delete dialog boxes in VPN Provisioning editor.<li>
<li>Revised open, save, delete dialog boxes in Provisioning editor.<li>
<li>Added networks validator and use in networks fields in VPN Provisioning editor.</li>
<li>Added cidr validators and use in server address fields in VPN Provisioning editor.</li>
<li>Add fields to VPN Agent dialog to bring up to date with Connman.</li>
<li>Added an option to scale icons and artwork (issue #256).</li>
<li>Fixed deselecting WiFi entry after automatic rescan (issue #226).</li>
<li>Added Edit button to Wifi Services (issue #202)</li>
<li>Removed obsolete managerRescan() function, moved code to where needed.</li>
<li>Fix VPN parsing not being done in various display elements (issue #192)</li>
</ul>
<b> 2022.01.05 </b>
<ul>
<li>Desktop entry in .config/autostart is saved when enable/disable is toggled (issue #238).</li>
<li>Removed --use-mate and --use-xfce options from program (issue #237)</li>
<li>Added line for Connman version to the About box.</li>
<li>Added new option to hide the system tray icon in normal operations (issue #235)</li>
<li>Auto run lupdate and embed translations automatically from make via qmake.</li>
<li>Added scroll bars to Agent dialog (issue #242).</li>
</ul>
<b> 2021.12.02</b>
<ul>
<li>Disable configuration button when service is VPN.</li>
<li>Fix for issue #240.</li>
<li>Pull Requests translations from Weblate.</li>
<li>Pull Request #218 (Fix getting ConnMan version)</li>
<li>Added translation to Bulgarian.</li>
</ul>
<b> 2020.11.01</b>
<ul>
<li>Added translation to Turkish by  Yaşar Çiv.</li>
<li>Work around for KDE no longer displaying rich text in system tray icon popups (issue #216).</li>
<li>Fixed compiler warnings on QT depreciated functions.</li>
</ul>
<b> 2020.05.09</b>
<ul>
<li>No longer extract key files from OpenVPN .opvn configurations.  Not needed.</li>
<li>Fixed UI where Advanced options were in Start Options group box.</li>
<li>Work on Prefereneces tab to make start options clearer (issue #210).</li>
<li>Added VPN internet kill switch.</li>
<li>Take VPN services out of move before/after menu.</li>
</ul>
<b> 2020.04.12</b>
<ul>
<li>Fixed wrong validator on fields that accept either IPV4 or IPv6 addresses.</li>
<li>Expanded IPv6 validator to accept most abbreviated addresses.</li>
<li>Peditor now uses the shared validator instead of its own.</li>
<li>Fixed update problems in details tab.</li>
<li>Fixed VPN tray icon not always showing (possibly issue #198).</li>
<li>Fixed notification daemon working and starting.</li>
<li>Added ability to execute a process prior to making a wifi or vpn connection (issue #194).</li>
</ul>
<b> 2020.03.07</b>
<ul>
<li>Move offline checkbox in tab 1 (issue # 201)</li>
<li>Translation to Dutch by Heimen Stoffels.</li>
<li>Cleaned up the IPv4 and IPv6 entries in the provisioning editor.</li>
<li>Fixed retain state not working for window size and position.</li>
<li>Additions for Connman 1.38</li>
<ul>
<li>Add mDNS status to the details tab.</li>
<li>Added mDNS enable or disable tool to provisioning editor.</li>
<li>Add Last Address Conflict information to details tab.</li>
<li>Added VPNC.DeviceType to VPN provisioning editor.</li>
<li>Added WireGuard configuration options to VPN Provisioning editor.</li>
<li>Added OpenVPN.DeviceType to VPN provisioning editor.</li>
<li>Added eight new OpenConnect items to VPN provisioning editor.</li>
<li>Added mDNS setting to the provisioning editor.</li>
<li>Added DeviceName field to the provisioning editor.</li>
<li>Added AnonymousIdentity field to the wifi section of the provisioning editor.</li>
<li>Added SubjectMatch and AltSubjectMatch fields to the wifi section of the provisioning editor. </li>
<li>Added DomainMatch and DomainSuffixMatch fields to the wifi section of the provisioning editor. </li>
</ul>
</ul>
<b> 2019.01.13</b>
<ul>
<li>Fixed segfault on close when running without Connman.</li>
<li>Revert network group to "netdev" in Slackware and Debian.</li>
<li>Pull request #183 (fixed typo in notification icon name).</li>
<li>Pull request #184 (correct dialog size on high DPI monitors).</li>
<li>PUll request #197 (add Spanish translation).</li>
<li>Fixed #188 missing README in tarball</li>
</ul>
<b> 2018.01.06</b>
<ul>
<li>Counters disabled by default, changed command line option -c to enable.</li>
<li>Disabled tabs are now hidden from view.</li>
<li>Do not change the visible service in the details tab if a service property changes and the service still exists.</li>
<li>Properties editor fixed to allow an empty gateway field in IPv4 and IPv6 connections (issue #148a)</li>
<li>Revise and enhance the properties editor dialog.</li>
<li>In VPN editor OpenVPN.AskPass changed from yes/no to file selector.</li>
<li>Allow move before/after on connected VPN services (issue #167).</li>
<li>Offline mode pixmap label now a pushbutton.</li>
<li>Offline mode engaged now shown as airplane, disengaged shown as radio.</li>
</ul>
<b> 2017.09.1</b>
<ul>
<li>Removed padding hack (issue #166) from id buttons.</li>
<li>Allow configuration of VPN services from the Details tab.</li>
<li>Allow CMST to close from window decoration if not running in system tray (issue #169).</li>
<li>Fix appdata.xml install location (issue #176).</li>
<li>Fixed No Reply popup starting VPN from system tray menu (issue #175).</li>
<li>Technologies and Services splitter state retained (issue #173).</li>
<li>Fixed segfault with ipv4 and ipv6 fields in VPN details.</li>
</ul>
<b> 2017.03.18</b>
<ul>
<li>Added Keywords to .desktop files (PR from klausenbusk).</li>
<li>Fixed missing send destination in dbus policy file (PR from Klausenbusk).</li>
<li>Fixed segfault where system tray icon could be used uninitialized.</li>
<li>Disable vpn tab and vpn icon menu if we cannot connect to the connman-vpn daemon (issue #155).</li>
<li>Notifications use system theme icons if available (issue #157).</li>
<li>New local icon for wifi tab (wifi_tab_state_not_ready) used to address issue #157.</li>
<li>Modify cmst.pro for Fedora build (issue #160 and applied submitted patch).</li>
</ul>
<b> 2016.10.02</b>
<ul>
<li>New commandline option -n (--disable-vpn) to disable VPN support (issue #144).</li>
<li>Fixed showing error dialog when connect is selected from the tray icon (issue #143).</li>
<li>Provisioning editor and properties editor nameserver and timeserver fields will now accept domain names in addition to IPv4 and IPv6 addresses (issue #146).</li>
<li>Added wifi rescan button to Wifi tab (issue #151).</li>
<li>Wifi rescan controls disabled during scans and if there is no powered Wifi technology found.</li>
</ul>
<b>2016.04.03</b>
<ul>
<li>Removed unnecessary calls to managerReacan from servicePropertyChanged slot.</li>
<li>Added nicknames for display to wired and hidden wifi connections.</li>
<li>Install application icons in all sizes and scalable.</li>
<li>Improvements to internal layouts.</li>
<li>Added appdata xml file.</li>
<li>Added ability to tether a technology.</li>
<li>Can reposition tabs in the main dialog.</li>
<li>Revise move before/after to only be active for and show services which can actually be moved.</li>
<li>Added three templates (EAP) to provisioning editor.</li>
</ul>
<b>2016.01.26</b>
<ul>
<li>Added a VPN tab to the main controlbox.</li>
<li>Can connect and disconnect already provisioned VPN services from controlbox.</li>
<li>Check for screen size at startup and adjust the initial size to fit if working on a small screen.</li>
<li>SignalBar class removed and replaced with QProgressBar styled using QStyleSheets.</li>
<li>VPN Editor available to help create new VPN connections.</li>
<li>OpenVPN files in .opvn format can be imported and used to provision a VPN service.</li>
</ul>
<b>2015.12.03</b>
<ul>
<li>CMST icon by Progandy was reworked and made cleaner by Hagabaka.</li>
<li>Added feature to run an external program automatically after a connect. The <i>Advanced Controls</i> checkbox must be checked to access this.</li>
<li>Expanded functionality of system tray icon menu to toggle power for technologies and to connect or disconnect wifi services.</li>
<li>System tray menu can be torn off and live in its own window on the desktop.</li>
<li>Internal icons can be colorized (color selector control on Preferences Tab).</li>
<li>Reworked internals to store text returned by Connman as is and only translate for display.</li>
<li>Fixed issue #118 (tray icon not visible in Plasma 5)</li>
<li>Fixed issue #119 (not starting when XDG_CURRENT_DESKTOP=kde is set and not actually running KDE).</li>
</ul>
<b>2015.10.03</b>
<ul>
<li>Browser selections in Agent dialog improved and added xdg-open option (by Yaohan Chen).</li>
<li>-i (--icon-theme) command line option will now accept a theme name.</li>
<li>Theme icons not part of the standard Freedesktop.org icon naming specification (mainly wifi signal strengths) will be used if available.</li>
<li>Counter update rate in preferences upper limit changed from 600 seconds to 86400 seconds.</li>
<li>Minimize to tray when ESC is pressed (by kriesoff).</li>
<li>Restoring window size and geometry is now independent from the other settings.</li>
<li>Added -b command line option to bypass restoring window state if that option is set in Preferences.</li>
<li>Added -B command line option to bypass all startup options set in Preferences.</li>
<li>New CMST icon (by Progandy).</li>
</ul>
<b>2015.03.01</b>
<ul>
<li>Translation to Chinese by Jianfeng Zhang.</li>
<li>Option to create a entry in the users autostart directory (coded by Lester Bico).</li>
<li>Added --use-mate command line option to try and work around system tray icon oddities.</li>
<li>Start options formally only available from the command line may now be set in preferences.</li>
<li>Added --fake-transparency command line option to try and work around system trays that display transparent backgrounds as opaque (generally white).</li>
</ul>
<b>2014.12.14</b>
<ul>
<li>If a Wifi service falls into the failure state provide an option to try and automatically reconnect.</li>
<li>Removed -r (--wife-scan-rate) command line option and all code internal for having CMST to WiFi scans.  This was conflicting with Connman auto scans.</li>
<li>Available services now shown with right click on system tray icon.</li>
</ul>
<b>2014.12.05</b>
<ul>
<li>Adding translations (Russian Complete).</li>
<li>Fixed response time for Agent dialog when it is needed.</li>
</ul>
<b>2014.11.24</b>
<ul>
<li>Added CMST icon.</li>
<li>Added --use-xfce command line option.  Code for XFCE that breaks KDE now must be called with this option.</li>
<li>Fixed integer overflow for counters.</li>
</ul>
<b>2014.11.18</b>
<ul>
<li>Removed incorrect validator from Properties Editor domains field.</li>
<li>Provisioning Editor to create and edit Connman service configuration files.</li>
<li>Systemtray icon will show "online" if there is exactly one connection showing in the ready state and no connections showing the online state.</li>
<li>Systemtray icon added for a connection in the "failure" state.</li>
<li>Fixed and cleaned up behavior of notifications and message boxes for various error conditions.</li>
</ul>
<b>2014.10.15</b>
<ul>
<li>Connect, Disconnect, and Remove buttons in the Wifi tab are disabled if no Wifi services are available.</li>
<li>If only one WiFi service exists it is no longer necessary to select it first before pressing the Connect button.</li>
<li>If only one WiFi service is connected it is no longer necessary to select it first before pressing the Disconnect button.</li>
<li>Single instance code now checked using a local socket, not shared memory.</li>
<li>If an instance of CMST is started while one is running the running copy will be raised, and a message about a second instance trying to start will be printed to stderr.</li>
<li>Wifi signal strength bar and techonlogy buttons now have frames around them so that they do not fill an entire table cell</li>
<li>Autoconnect property can be set or unset from the property editor.</li>
<li>Fixed the IPv6 validator in the properties editor.</li>
</ul>
<b>2014.08.23</b>
<ul>
<li>Removed tooltips for obvious controls.  Tooltips now are only available for dynamic GUI elements (unless the user disables them in preferences).</li>
<li>Detailed service configuration dialog.</li>
<li>Added scrollbars and additional information to the service details tab.</li>
</ul>
<b>2014.07.19</b>
<ul>
<li>UI updated to allow notifications from the system tray icon or from a notification server.</li>
<li>Notifications can be sent to a notification server if present.</li>
<li>Accomodate P2P technologies (display only)</li>
<li>Scan WiFi button moved to Technologies box and renamed "Rescan". No change in function, just a more accurate representation of what the button does.</li>
<li>Connections in the "Ready" state show ready with an appropriate icon in the system tray instead of showing disconnected.</li>
</ul>
<b>2014.07.01	</b>
<ul>
<li>Added "scan wifi" button to force a rescan of wifi sevices.</li>
<li>Added a checkbox to preferences to reset the counters at startup and when a service changes.</li>
<li>Finished the internal rework to catch and process dbus signals.</li>
</ul>
<b>2014.06.22	</b>
<ul>
<li>Check to make sure only a single instance of the program can be run.</li>
<li>Shipped with a .desktop file and icon.</li>
<li>Internal changes to catching dbus signals.</li>
</ul>
<b>2014.06.14</b>
<ul>
<li>Selecting "Maximize" from the tray icon will show the dialog "normal" instead of "maximized".</li>
<li>Enabled display of size grip in corner of dialog</li>
<li>Added option to show fewer details in the Services box on page 1</li>
<li>Fixed wordwrap in the Counters tab</li>
<li>Added an entry for the Counters tab in the Help tab, and added scroll bars to the help field.</li>
<li>GUI settings can be saved and restored between sessions.</li>
<li>Improved response when toggling the power state of a technology.</li>
<li>Added Preferences tab, tooltips are now disabled by default, added checkbox in Preferences to enable them.</li>
<li>Forced small delay in starting the system tray icon.</li>
<li>Limit the amount the dialog can shrink.</li>
<li>Replaced Nuvola icons with AwOken icons.</li>
<li>A manpage is now provided and installed.</li>
<li>The system tray icon can optionally show notify messages in popups.</li>
</ul>
<b>2014.05.10</b>
<ul>
<li>Left mouse click in system tray will toggle the interface up and down (coded by: Brett Dutro)
<li>Option to use system icon theme if available</li>
<li>Added MoveBefore and MoveAfter buttons to services on first page</li>
</ul>
<b>2014.03.29 - </b>Revised per input from Arch Linux Forums
<ul>
<li>Added command line option to wait a specified time to create the system tray</li>
</ul>
<b>2014.03.13 - </b>Revised per input from Arch Linux Forums
<ul>
<li>Command line options to show help, version, disable the system tray and start the program minimized.</li>
<li>Added SSID field to the agent request information dialog.</li>
<li>Added check to make sure a system tray exists before we try to use it.</li>
<li>Added option to log the input request from the connman daemon.</li>
</ul>
<b>2014.01.18 - </b>Revised
<ul>
<li>Improved error dialog in Agent and ask for retry on bad password.</li>
</ul>
<b>2014.01.14 - </b>Revised
<ul>
<li>Fixed up tooltip popup on system tray icon</li>
</ul>
<b>2014.01.11 - </b>Posted to Arch Linux Forum
<ul>
<li>Added the counters and the Counters tab</li>
<li>Fixed a SEGFAULT when connecting a Wifi service after the service order had changed.</li>
<li>Added message dialogs in the logerrors function to show errors to the user (errors are still logged to the journal).</li>
<li>Fixed SEGFAULTS if the program fails to find or connect to DBUS</li>
<li>Added a button on the WiFi page to remove a Wifi service</li>
</ul>
<b>2014.01.05 - </b>Initial Version
<ul>
<li>View and set global connection properties</li>
<li>List known technologies and services</li>
<li>View detailed information about services</li>
<li>Basic WiFi service management</li>
</ul>
